<?php
function weblog($mensaje) {
    try {
        //$mensaje = mb_convert_encoding($mensaje, 'UTF-8', 'OLD-ENCODING');
        $filename = 'weblog/log_' . date("j.n.Y") . '.html';
        if (file_exists($filename)) {
            //$mensaje .=  " -- " . date('H:i');
        } else {
            $mensaje = "<html lang='es'><head><title>log send_analisis_data</title><meta charset='UTF-8'></head><body>" . $mensaje;
        }
        // file_put_contents($filename, PHP_EOL . $mensaje . " -- " . date('H:i') , FILE_APPEND);
        chmod($filename, 0777);
    } catch  (Exception $e) {
        echo 'Excepción capturada: ', $e->getMessage(), "\n";
    }
}

function html($text)
{
  return htmlspecialchars($text, ENT_QUOTES, 'UTF-8');
}

function htmlout($text)
{
  echo html($text);
}

function markdown2html($text)
{
  $text = html($text);

  // strong emphasis
  $text = preg_replace('/__(.+?)__/s', '<strong>$1</strong>', $text);
  $text = preg_replace('/\*\*(.+?)\*\*/s', '<strong>$1</strong>', $text);

  // emphasis
  $text = preg_replace('/_([^_]+)_/', '<em>$1</em>', $text);
  $text = preg_replace('/\*([^\*]+)\*/', '<em>$1</em>', $text);

  // Convert Windows (\r\n) to Unix (\n)
  $text = str_replace("\r\n", "\n", $text);
  // Convert Macintosh (\r) to Unix (\n)
  $text = str_replace("\r", "\n", $text);

  // Paragraphs
  $text = '<p>' . str_replace("\n\n", '</p><p>', $text) . '</p>';
  // Line breaks
  $text = str_replace("\n", '<br>', $text);

  // [linked text](link URL)
  $text = preg_replace(
      '/\[([^\]]+)]\(([-a-z0-9._~:\/?#@!$&\'()*+,;=%]+)\)/i',
      '<a href="$2">$1</a>', $text);

  return $text;
}

function markdownout($text)
{
  echo markdown2html($text);
}
